#include "COpenGLContextWin32.h"
#include "COpenGLUtils.h"
#include "os.h"


#ifdef _IRR_COMPILE_WITH_WINDOWS_DEVICE_
#ifdef _IRR_COMPILE_WITH_OPENGL_

namespace irr
{
namespace video
{
COpenGLContextWin32::COpenGLContextWin32(COpenGLDriver* driver
                                         , const int& pixelFormat
                                         , const SVideoContextConfig& config, bool external, HDC deviceContext, HGLRC hrd
                                         ) :

    IOpenGLContext(driver, config, external)
    , RenderingContext(hrd)
    , DeviceContext(deviceContext)
    , PixelFormat(pixelFormat)
    {
        _IRR_DEBUG_BREAK_IF(hrd == 0);
    }



COpenGLContextWin32::~COpenGLContextWin32()
{

}


bool COpenGLContextWin32::isCompatibleWithRenderWindow(IRenderWindow*) const
{
    // TODO
    // GetPixelFormat()
//
//PIXELFORMATDESCRIPTOR  pfd;
//HDC  hdc;
//int  iPixelFormat;
//
//// get the current pixel format index GetPixelFormat
//iPixelFormat = GetPixelFormat(deviceContext);
//
//// obtain a detailed description of that pixel format
//DescribePixelFormat(hdc, iPixelFormat,
//        sizeof(PIXELFORMATDESCRIPTOR), &pfd);

    return true;
}


bool COpenGLContextWin32::setDeviceContext(HDC deviceContext)
{

//PIXELFORMATDESCRIPTOR  pfd;
//HDC  hdc;
//int  iPixelFormat;
//
//// get the current pixel format index GetPixelFormat
//iPixelFormat = GetPixelFormat(deviceContext);
//
//// obtain a detailed description of that pixel format
//DescribePixelFormat(hdc, iPixelFormat,
//        sizeof(PIXELFORMATDESCRIPTOR), &pfd);

}


//bool COpenGLContextWin32::setCurrent(HDC DeviceContext)
bool COpenGLContextWin32::setTarget(void *videoData)
{

    HDC deviceContext = reinterpret_cast<HDC>(videoData);
    if(!deviceContext)
    {
        os::Printer::log("Invalid device context ", ELL_ERROR);
        return false;
    }
    else
    {
        DeviceContext = deviceContext;
    }

//
PIXELFORMATDESCRIPTOR  pfd;
//HDC  hdc;
//int  iPixelFormat;
//
//// get the current pixel format index GetPixelFormat
    int iPixelFormat = GetPixelFormat(deviceContext);
    if( iPixelFormat == 0)
    {
        //! TODO try to set color format if it fails return false
        os::Printer::log("Pixel format not set yet. Trying to set a compatible one", ELL_WARNING);


//        ChoosePixelFormat(temporary_hdc, &pfd);
        // TODO might want to fill pfd with correct info before
        if ( SetPixelFormat( deviceContext, PixelFormat, &pfd) == FALSE)
        {
            os::Printer::log("This pixel format is not supported by this DC.", ELL_WARNING);
            return false;
        }

    }
    else if(iPixelFormat != PixelFormat)
    {
        os::Printer::log("Incompatible pixel format", ELL_ERROR);
        return false;
    }
//
//// obtain a detailed description of that pixel format
//DescribePixelFormat(hdc, iPixelFormat,
//        sizeof(PIXELFORMATDESCRIPTOR), &pfd);

//BOOL WINAPI SetPixelFormat(
//  HDC hdc,
//  int iPixelFormat,
//  const PIXELFORMATDESCRIPTOR *ppfd
//);

    if(wglMakeCurrent(deviceContext, RenderingContext) != TRUE)
    {
        os::Printer::log("Could not set gl rendering context as current",ELL_ERROR);

//        ReleaseDC(DeviceContext);
        return false;
    }
    else
    {
        DeviceContext = deviceContext;
        return true;
    }

    return false;
//    return wglMakeCurrent(DeviceContext, RenderingContext) == TRUE;
}





//bool COpenGLContextWin32::endCurrent()
//{
////    if(wglGetCurrentContext() == DeviceContext)
//        return wglMakeCurrent((HDC)0, (HGLRC)0) == TRUE;
//
//}



// rename
bool COpenGLContextWin32::swapBuffers()
{
//    HDC DeviceContext = wglGetCurrentDC();

    // render window;
    if (DeviceContext)
        return SwapBuffers(DeviceContext) == TRUE;

//    ReleaseDC(DeviceContext);

    return false;
}


void COpenGLContextWin32::releaseContext()
{
//    if()
    wglDeleteContext(RenderingContext);
//    ReleaseDC(DeviceContext);
}



} // video
} // irr


#endif // #ifdef _IRR_COMPILE_WITH_OPENGL_
#endif // _IRR_COMPILE_WITH_WINDOWS_DEVICE_
