#include "EDriverTypes.h"
#include "IrrlichtDevice.h"
#include "COpenGLDriver.h"
#include "CSoftwareDriver.h"
//#include "CSoftwareDriver2.h"
#include "CD3D9Driver.h"
#include "IRenderWindow.h"


namespace irr
{

namespace video
{


const TDriverType _IRR_DEFAULT_DRIVER = "software";



#ifdef _IRR_COMPILE_WITH_OPENGL_
IVideoDriver* createOpenGLDriver(
	IrrlichtDevice* device
	)
{

	COpenGLDriver* ogl =  new COpenGLDriver(
                            device->getFileSystem(),
                            device
                            );
	return ogl;
}
#endif // _IRR_COMPILE_WITH_OPENGL_




#ifdef _IRR_COMPILE_WITH_SOFTWARE_
IVideoDriver* createSoftwareDriver( IrrlichtDevice* device)
{




//    core::dimension2du dims(640,480);

	CSoftwareDriver* softDriver = new CSoftwareDriver(
                            device->getFileSystem()
                            , device->getImageManager()
                            );

    return softDriver ;


}

#endif



#ifdef _IRR_COMPILE_WITH_DIRECT3D_9_
IVideoDriver* createDirectX9Driver(
               IrrlichtDevice* device
			)

//! creates a video driver

{

//	const bool pureSoftware = false;



	CD3D9Driver* dx9 = 0;
    dx9 = new CD3D9Driver(
//                        device->CreationParams,
                        device->getFileSystem()
                        , device->getImageManager()
                        );

	if (!dx9->initDriver() )
	{
		dx9->drop();
		return 0;
	}
	return dx9;



}
#endif // _IRR_COMPILE_WITH_DIRECT3D_9_


//! creates a video driver
IVideoDriver* createBurningVideoDriver( IrrlichtDevice* device )
{
	#ifdef _IRR_COMPILE_WITH_BURNINGSVIDEO_
	return new CBurningVideoDriver(
//                                params,
//                                io,
//                                presenter
                                device->getFileSystem(),
                                device->getImageManager()
                                );
	#else
	return 0;
	#endif // _IRR_COMPILE_WITH_BURNINGSVIDEO_
}



} //!< video
} //!< irr
