
// Copyright (C) 2002-2011 Nikolaus Gebhardt
// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in irrlicht.h

#ifndef __I_OPENGL_CONTEXT_H_INCLUDED__
#define __I_OPENGL_CONTEXT_H_INCLUDED__



#include "IrrCompileConfig.h"

#ifdef _IRR_COMPILE_WITH_OPENGL_

#include "IVideoContext.h"

namespace irr
{
namespace video
{

    class COpenGLDriver;
    class COpenGLTexture;
    class ITexture;

// TODO to replace SExposedVideoData
class IOpenGLContext : public IVideoContext
{
public:

    IOpenGLContext(COpenGLDriver* driver, const SVideoContextConfig& config, bool external) :

        IVideoContext(config, external)
        , VideoDriver(driver)
    {
        _IRR_DEBUG_BREAK_IF( VideoDriver == 0);
    }

    virtual ~IOpenGLContext()
    {
        //!
    }


    virtual bool setTarget(void *data) = 0;


    virtual core::dimension2du getSize() const
    {
        return getConfig().ContextSize;
    }

    virtual bool setSize( const core::dimension2du& dims )
    {
        return false;
    }


    virtual bool swapBuffers() = 0;
    virtual COpenGLDriver* getVideoDriver() const ;




//    virtual void removeAllTextures();
//    virtual COpenGLTexture* findTexture();
//    virtual void findTexture();

    private:
        COpenGLDriver* VideoDriver;

};

}
}

#endif // _IRR_COMPILE_WITH_OPENGL_

#endif
