#include "IrrCompileConfig.h"


#ifdef _IRR_COMPILE_WITH_X11_DEVICE_
#ifdef _IRR_COMPILE_WITH_SOFTWARE_


#include "ISoftwareContextLinux.h"
#include "os.h"
#include "CColorConverter.h"


namespace irr
{
namespace video
{


ISoftwareContextLinux::ISoftwareContextLinux(XImage* image) :
    SoftwareImage(image)
{

//    _IRR_DEBUG_BREAK_IF();
}


ISoftwareContextLinux::~ISoftwareContextLinux()
{
    //!
}




bool ISoftwareContextLinux::setTarget(const SRenderWindowLinuxHandle& handle)
{
    //!
//    SRenderWindowLinuxHandle handle =
//    if(!data)
//    {
//        os::Printer::log("Null video data", ELL_WARNING);
//        return false;
//    }
//
//    VideoData = *reinterpret_cast<SRenderWindowLinuxHandle*>(data) ;
    VideoData = handle;
    return true;
}



//   virtual bool swapBuffers(IImage* image, core::rect<s32>* src) ;
bool ISoftwareContextLinux::swapBuffers(video::IImage* image, core::rect<s32>* srcRect)
{
#ifdef _IRR_COMPILE_WITH_X11_
	// this is only necessary for software drivers.
	if (!image)
    {
		return true;
    }
//image

//    Display *display = VideoData.X11Connection;

    _IRR_DEBUG_BREAK_IF( SoftwareImage == 0);

	// thx to Nadav, who send me some clues of how to display the image
	// to the X Server.

	const u32 destwidth = SoftwareImage->width;
	const u32 minWidth = core::min_(image->getDimension().Width, destwidth);
	const u32 destPitch = SoftwareImage->bytes_per_line;

	video::ECOLOR_FORMAT destColor;
	switch (SoftwareImage->bits_per_pixel)
	{
		case 16:
			if (SoftwareImage->depth==16)
				destColor = video::ECF_R5G6B5;
			else
				destColor = video::ECF_A1R5G5B5;
		break;
		case 24: destColor = video::ECF_R8G8B8; break;
		case 32: destColor = video::ECF_A8R8G8B8; break;
		default:
			os::Printer::log("Unsupported screen depth.");
			return false;
	}

    // convert software image
	u8* srcdata = reinterpret_cast<u8*>(image->lock());
	u8* destData = reinterpret_cast<u8*>(SoftwareImage->data);

	const u32 destheight = SoftwareImage->height;
	const u32 srcheight = core::min_(image->getDimension().Height, destheight);
	const u32 srcPitch = image->getPitch();
	for (u32 y=0; y!=srcheight; ++y)
	{
		video::CColorConverter::convert_viaFormat(srcdata,image->getColorFormat(), minWidth, destData, destColor);
		srcdata+=srcPitch;
		destData+=destPitch;
	}
	image->unlock();

	GC gc = DefaultGC( VideoData.X11Connection, DefaultScreen( VideoData.X11Connection ) );
//	VideoData myWindow=window;
//	if (windowId)
//		myWindow = reinterpret_cast<VideoData>(windowId);
	XPutImage(VideoData.X11Connection, VideoData.WindowId, gc, SoftwareImage, 0, 0, 0, 0, destwidth, destheight);
	return true;
#endif
	return false;
}


void ISoftwareContextLinux::releaseContext()
{

    if (SoftwareImage)
        XDestroyImage(SoftwareImage);
}
}
}

#endif //

#endif // _IRR_COMPILE_WITH_X11_DEVICE_
